(define (cube-root x)
  (define tolerance 1e-10)
  (define (within-tolerance? x y)
    (< (abs (- x y)) tolerance))
  (define (square x) (* x x))
  (define (cube x) (* x x x))
  (define (good-enough? guess)
    (within-tolerance? x (cube guess)))
  (define (improve guess)
    (/ (+ (/ x (square guess)) (* 2 guess)) 3))
  (define (iter guess)
    (if (good-enough? guess)
      guess
      (iter (improve guess))))
  (iter 1.0))
